<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/31/2010 *
 * ===================                          Last change: 08/31/2010 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_networks.php                         *
 * -------------------------------------------------------------------- *
 * Short description : Advertisement Network Configuration              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Werbenetzwerkkonfiguration                       *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// By default we should display list/add new forms
$GLOBALS['network_display'] = true;

// Handle form here
doNetworkHandleForm();

// Display forms?
if ($GLOBALS['network_display'] === false) {
	// Abort here
	return;
} // END - if

// Check all networks that doesn't have a configuration entry
$result = SQL_QUERY("SELECT
	d.`network_id`, d.`network_short_name`, d.`network_title`, d.`network_reflink`,
	c.`network_affiliate_id`, c.`network_api_password`, c.`network_site_id`, c.`network_query_amount`, c.`network_active`
FROM
	`{?_MYSQL_PREFIX?}_network_data` AS `d`
LEFT JOIN
	`{?_MYSQL_PREFIX?}_network_config` AS `c`
ON
	d.`network_id`=c.`network_id`
ORDER BY
	d.`network_short_name` ASC", __FILE__, __LINE__);

// Do we have entries?
if (!SQL_HASZERONUMS($result)) {
	// We have some networks here
	$OUT = '';
	while ($content = SQL_FETCHARRAY($result)) {
		// Fix empty 'active' to 'yes'
		if (is_null($content['network_active'])) {
			// Fix it for our API function
			$content['network_active'] = 'Y';
		} // END - if

		// Add network row
		$OUT .= loadTemplate('admin_list_network_config_row', true, $content);
	} // END - while

	// Load main template
	loadTemplate('admin_list_network_config', false, $OUT);
} else {
	// Please setup some networks first
	loadTemplate('admin_settings_saved', false, '{--ADMIN_NETWORK_DATA_MISSING--}');
}
// Free result
SQL_FREERESULT($result);

// [EOF]
?>
