<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/28/2004 *
 * ===================                          Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_links.php                              *
 * -------------------------------------------------------------------- *
 * Short description : List unconfirmed mails of a member               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Unbest&auml;tigte Mails eines Mitgliedes auflisten   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (!isExtensionActive('mailid')) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('mailid'));
	return;
} // END - if

if (isGetRequestParameterSet('userid')) {
	// Check if the user already exists
	if (fetchUserData(getRequestParameter('userid'))) {
		// Grab user's all unconfirmed mails
		// @TODO Try to rewrite this to a filter
		if (isExtensionActive('bonus')) {
			// Load bonus id
			$result = SQL_QUERY_ESC("SELECT `stats_id`, `bonus_id`, `link_type` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `userid`=%s ORDER BY `id` ASC",
				array(bigintval(getRequestParameter('userid'))), __FILE__, __LINE__);
		} else {
			// Load stats id (2nd will be ignored later! But it is needed for the same fetchrow command)
			$result = SQL_QUERY_ESC("SELECT `stats_id`, `stats_id`, `link_type` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `userid`=%s ORDER BY `id` ASC",
				array(bigintval(getRequestParameter('userid'))), __FILE__, __LINE__);
		}

		// Do we have some entries?
		if (!SQL_HASZERONUMS($result)) {
			// Some unconfirmed mails left
			if (getRequestParameter('delete') == "all") {
				// Delete all unconfirmed mails by this user
				SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `userid`=%s LIMIT %s",
					array(bigintval(getRequestParameter('userid')), SQL_NUMROWS($result)), __FILE__, __LINE__);

				// Prepare mail and send it away
				$message = loadEmailTemplate('admin-del_links', SQL_NUMROWS($result), bigintval(getRequestParameter('userid')));
				sendEmail(getUserData('email'), '{--ADMIN_DELETE_LINK_SUBJECT--}', $message);

				// Display message
				loadTemplate('admin_settings_saved', false, '{--ADMIN_LINKS_DELETED--}');
			} else {
				// Init variables
				$OUT = '';

				// List all unconfirmed mails
				// @TODO Find a way to rewrite this. See some lines above for different queries
				while (list($id, $id2, $type) = SQL_FETCHROW($result)) {
					// Initializes some variables
					$cat = '';
					$DATA = '';
					$PROBLEM = '{--ADMIN_GENERAL_MAIL_PROBLEM--}';
					$result_data = false; // Closes Bug #58

					// Load data from stats table...
					// @TODO Rewrite this to includes/filter
					switch ($type) {
						case 'NORMAL':
							$result_data = SQL_QUERY_ESC("SELECT `subject`, `timestamp_ordered` AS `timestamp`, `cat_id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `id`=%s LIMIT 1",
								array(bigintval($id)), __FILE__, __LINE__);
							$type = 'mailid'; $DATA = $id; $PROBLEM = '{--NORMAL_MAIL_PROBLEM--}';
							$LINK = '<a href="{%url=mailid.php?userid=' . getRequestParameter('userid') . '&amp;mailid=' . $id . '%}" target="_blank">' . $id . '</a>';
							break;

						case 'BONUS':
							$result_data = SQL_QUERY_ESC("SELECT `subject`, `timestamp`, `cat_id` FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `id`=%s LIMIT 1",
								array(bigintval($id2)), __FILE__, __LINE__);
							$type = 'bonusid'; $DATA = $id2; $PROBLEM = '{--BONUS_MAIL_PROBLEM--}';
							$LINK = '<a href="{%url=mailid.php?userid=' . getRequestParameter('userid') . '&amp;bonusid=' . $id2 . '%}" target="_blank">' . $id2 . '</a>';
							break;

						default: // Problem in application detected!
							// Log the error
							logDebugMessage(__FILE__, __LINE__, sprintf("Invalid email type %s detected.", $type));
							break;
					} // END - switch

					// Do we have an entry?
					if (SQL_NUMROWS($result_data) == 1) {
						// Mail was found!
						$content = SQL_FETCHARRAY($result_data);

						// Fix empty subject
						if (empty($content['subject'])) $content['subject'] = '{--DEFAULT_SUBJECT_LINE--}';

						// Prepare data for the row template
						$content = array(
							'link'      => $LINK,
							'subject'   => $content['subject'],
							'timestamp' => generateDateTime($content['timestamp'], 0),
							'cat_id'    => $content['cat_id'],
						);

						// Load row template
						$OUT .= loadTemplate('admin_list_links_row', true, $content);
					} else {
						// Load template for error
						$OUT .= loadTemplate('admin_list_links_problem', true,
							array(
								'problem'	=> $PROBLEM,
								'data'		=> $DATA
							)
						);
					}

					// Free result
					SQL_FREERESULT($result_data);
				} // END - while

				// Remember list in constant for the template
				$content['surname'] = getUserData('surname');
				$content['family']  = getUserData('family');
				$content['email']   = '<a href="' . generateEmailLink(getUserData('email'), 'user_data') . '">' . getUserData('email') . '</a>';
				$content['rows']    = $OUT;
				$content['nums']    = SQL_NUMROWS($result);
				$content['userid']  = bigintval(getRequestParameter('userid'));

				// Free memory
				SQL_FREERESULT($result);

				// Load final template
				loadTemplate('admin_list_links', false, $content);
			}
		} else {
			// No mails left to confirm
			loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_MEMBER_LINKS', bigintval(getRequestParameter('userid'))));
		}
	} else {
		// User not found
		loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_MEMBER_404', bigintval(getRequestParameter('userid'))));
	}
} else {
	// Output selection form with all confirmed user accounts listed
	addMemberSelectionBox();
}

// [EOF]
?>
