<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 02/25/2004 *
 * ===================                          Last change: 02/25/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-repair_amenu.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Repair admin menu weight                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Menuegewichtigung reparieren                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

$actions = array();

// First fix all main menus (what = '')...
$result_fix = SQL_QUERY("SELECT `id`, `action` FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE (`what`='' OR `what` IS NULL) AND `action` != 'logout' ORDER BY `sort` ASC", __FILE__, __LINE__);
$count = '0'; $repairedWeights = '0';
while ($content = SQL_FETCHARRAY($result_fix)) {
	// Store act value for later usage in sorting sub menus
	$actions[] = $content['action'];

	// Fix weight
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET sort=%s WHERE `id`=%s LIMIT 1",
		array($count, $content['id']), __FILE__, __LINE__);
	$repairedWeights += SQL_AFFECTEDROWS();

	// Count one up
	$count++;
} // END - while

// Set logout weight to 999
SQL_QUERY("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `sort`='999' WHERE `action`='logout' AND (`what`='' OR `what` IS NULL) LIMIT 1", __FILE__, __LINE__);

// Now sort every each menu
foreach ($actions as $action) {
	$result_fix = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='%s' AND `what` != '' AND `what` IS NOT NULL ORDER BY `sort` ASC",
		array($action), __FILE__, __LINE__);
	$count = 1;
	while ($content = SQL_FETCHARRAY($result_fix)) {
		// Fix weight
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `sort`=%s WHERE `id`=%s LIMIT 1",
			array($count, $content['id']), __FILE__, __LINE__);
		$repairedWeights += SQL_AFFECTEDROWS();

		// Count one up
		$count++;
	} // END - while
} // END - foreach

// Repair finished
if ($repairedWeights > 0) {
	$message = getMaskedMessage('ADMIN_REPAIR_ENTRIES_FIXED', $repairedWeights);
} else {
	$message = '{--ADMIN_REPAIR_NOTHING_FIXED--}';
}

// Output message
loadTemplate('admin_settings_saved', false, $message);

// [EOF]
?>
