<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/26/2003 *
 * ===================                          Last change: 11/29/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mysql-manager.php                                *
 * -------------------------------------------------------------------- *
 * Short description : All MySQL-related functions                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle MySQL-Relevanten Funktionen                 *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// "Getter" for module description
// @TODO Can we cache this?
function getTitleFromMenu ($mode, $what, $column = 'what', $ADD='') {
	// Fix empty 'what'
	if (empty($what)) {
		$what = getIndexHome();
	} // END - if

	// Default is not found
	$data['title'] = '??? (' . $what . ')';

	// Look for title
	$result = SQL_QUERY_ESC("SELECT `title` FROM `{?_MYSQL_PREFIX?}_%s_menu` WHERE `%s`='%s'" . $ADD . " LIMIT 1",
		array(
			$mode,
			$column,
			$what
		), __FUNCTION__, __LINE__);

	// Is there an entry?
	if (SQL_NUMROWS($result) == 1) {
		// Fetch the title
		$data = SQL_FETCHARRAY($result);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return it
	return $data['title'];
}

// Add menu description pending on given file name (without path!)
function addMenuDescription ($accessLevel, $FQFN, $return = false) {
	// Use only filename of the FQFN...
	$file = basename($FQFN);

	// Init variables
	$LINK_ADD = '';
	$OUT = '';
	$ADD = '';
	$prefix = '';

	// First we have to do some analysis...
	if (substr($file, 0, 7) == 'action-') {
		// This is an action file!
		$type = 'action';
		$search = substr($file, 7);

		// Get access level from it
		$modCheck = getModuleFromFileName($file, $accessLevel);

		// Add what
		$ADD = " AND (`what`='' OR `what` IS NULL)";
	} elseif (substr($file, 0, 5) == 'what-') {
		// This is a 'what file'!
		$type = 'what';
		$search = substr($file, 5);
		$ADD = " AND `visible`='Y' AND `locked`='N'";

		// Get access level from it
		$modCheck = getModuleFromFileName($file, $accessLevel);

		// Do we have admin? Then display all
		if (isAdmin()) $ADD = '';

		$dummy = substr($search, 0, -4);
		$ADD .= sprintf(" AND `action`='%s'", getActionFromModuleWhat($accessLevel, $dummy));
	} elseif (($accessLevel == 'sponsor') || ($accessLevel == 'engine')) {
		// Sponsor / engine menu
		$type     = 'what';
		$search   = $file;
		$modCheck = getModule();
		$ADD      = '';
	} else {
		// Other
		$type     = 'menu';
		$search   = $file;
		$modCheck = getModule();
		$ADD      = '';
	}

	// Begin the navigation line
	if (!isset($GLOBALS['nav_depth'])) {
		// Init nav_depth
		$GLOBALS['nav_depth'] = '0';

		// Run the pre-filter chain
		$ret = runFilterChain('pre_youhere_line', array('access_level' => $accessLevel, 'type' => $type, 'content' => ''));

		// Add pre-content
		$prefix = $ret['content'];

		$prefix .= '<div class="you_are_here">{--YOU_ARE_HERE--}&nbsp;<strong><a class="you_are_here" href="{%url=modules.php?module=' . getModule() . $LINK_ADD . '%}">Home</a></strong>';
	} elseif ($return === false) {
		// Count depth
		$GLOBALS['nav_depth']++;
	}

	$prefix .= '&nbsp;-&gt;&nbsp;';

	// We need to remove .php and the end
	if (substr($search, -4, 4) == '.php') {
		// Remove the .php
		$search = substr($search, 0, -4);
	} // END - if

	if (((isExtensionInstalledAndNewer('sql_patches', '0.2.3')) && (getConfig('youre_here') == 'Y')) || ((isAdmin()) && ($modCheck == 'admin'))) {
		// Output HTML code
		$OUT = $prefix . '<strong><a class="you_are_here" href="{%url=modules.php?module=' . $modCheck . '&amp;' . $type . '=' . $search . $LINK_ADD . '%}">' . getTitleFromMenu($accessLevel, $search, $type, $ADD) . '</a></strong>';

		// Can we close the you-are-here navigation?
		//* DEBUG: */ debugOutput(__LINE__.'*'.$type.'/'.getWhat().'*');
		if (($type == 'what') || (($type == 'action') && ((!isWhatSet()) || (getWhat() == 'overview')))) {
			//* DEBUG: */ debugOutput(__LINE__.'+'.$type.'+');
			// Add closing div and br-tag
			$OUT .= '</div>';
			$GLOBALS['nav_depth'] = '0';

			// Run the post-filter chain
			$ret = runFilterChain('post_youhere_line', array('access_level' => $accessLevel, 'type' => $type, 'content' => ''));

			// Add additional content
			$OUT .= $ret['content'];
		} // END - if
	} // END - if

	// Return or output HTML code?
	if ($return === true) {
		// Return HTML code
		return $OUT;
	} else {
		// Output HTML code here
		outputHtml($OUT);
	}
}

// Adds a menu (mode = guest/member/admin/sponsor) to output
function addMenu ($mode, $action, $what) {
	// Init some variables
	$main_cnt = '0';
	$ADD = '';

	// is the menu action valid?
	if (!isMenuActionValid($mode, $action, $what, true)) {
		return getCode('MENU_NOT_VALID');
	} // END - if

	// Non-admin shall not see all menus
	if (!isAdmin()) {
		$ADD = " AND `visible`='Y' AND `locked`='N'";
	} // END - if

	// Load SQL data and add the menu to the output stream...
	$result_main = SQL_QUERY_ESC("SELECT
	`title`, `what`, `action`, `visible`, `locked`
FROM
	`{?_MYSQL_PREFIX?}_%s_menu`
WHERE
	(`what`='' OR `what` IS NULL)
	".$ADD."
ORDER BY
	`sort` ASC",
		array($mode), __FUNCTION__, __LINE__);

	//* DEBUG: */ debugOutput(__LINE__.'/'.$main_cnt.':'.getWhat().'*');
	if (!SQL_HASZERONUMS($result_main)) {
		// There are menus available, so we simply display them... :)
		$GLOBALS['rows'] = '';
		while ($content = SQL_FETCHARRAY($result_main)) {
			//* DEBUG: */ debugOutput(__LINE__ . '/' . $main_cnt . '/' . $content['action'] . ':' . getWhat() . '*');
			// Disable the block-mode
			enableBlockMode(false);

			// Load menu header template
			$GLOBALS['rows'] .= loadTemplate($mode . '_menu_title', true, $content);

			// Sub menu
			$result_sub = SQL_QUERY_ESC("SELECT
	`title` AS `sub_title`,
	`what` AS `sub_what`,
	`visible` AS `sub_visible`,
	`locked` AS `sub_locked`
FROM
	`{?_MYSQL_PREFIX?}_%s_menu`
WHERE
	`action`='%s' AND
	`what` != '' AND
	`what` IS NOT NULL
	".$ADD."
ORDER BY
	`sort` ASC",
				array($mode, $content['action']), __FUNCTION__, __LINE__);

			// Do we have some entries?
			if (!SQL_HASZERONUMS($result_sub)) {
				// Init counter
				$count = '0';

				// Load all sub menus
				while ($content2 = SQL_FETCHARRAY($result_sub)) {
					// Merge both arrays in one
					$content = merge_array($content, $content2);

					// Init content
					$OUT = '';

					// Full file name for checking menu
					//* DEBUG: */ debugOutput(__LINE__ . ':!!!!' . $content['sub_what'] . '!!!');
					$inc = sprintf("inc/modules/%s/what-%s.php", $mode, $content['sub_what']);
					if (isIncludeReadable($inc)) {
						// Mark currently selected menu - open
						if ((!empty($what)) && (($what == $content['sub_what']))) {
							$OUT = '<strong>';
						} // END - if

						// Navigation link
						$OUT .= '<a name="menu" class="menu_blur" href="{%url=modules.php?module=' . getModule() . '&amp;what=' . $content['sub_what'] . '%}" target="_self">';
					} else {
						// Not found! - open
						$OUT .= '<em style="cursor:help" class="notice" title="{%message,MENU_WHAT_404=' . $content['sub_what'] . '%}">';
					}

					// Menu title
					$OUT .= '{?menu_blur_spacer?}' . $content['sub_title'];

					if (isIncludeReadable($inc)) {
						$OUT .= '</a>';

						// Mark currently selected menu - close
						if ((!empty($what)) && (($what == $content['sub_what']))) {
							$OUT .= '</strong>';
						} // END - if
					} else {
						// Not found! - close
						$OUT .= '</em>';
					}

					// Cunt it up
					$count++;

					// Rewrite array
					$content = array(
						'menu'    => $OUT,
						'what'    => $content['sub_what'],
						'visible' => $content['sub_visible'],
						'locked'  => $content['locked'],
					);

					// Add regular menu row or bottom row?
					if ($count < SQL_NUMROWS($result_sub)) {
						$GLOBALS['rows'] .= loadTemplate($mode . '_menu_row', true, $content);
					} else {
						$GLOBALS['rows'] .= loadTemplate($mode . '_menu_bottom', true, $content);
					}
				} // END - while
			} else {
				// This is a menu block... ;-)
				enableBlockMode();

				// Load menu block
				$INC = sprintf("inc/modules/%s/action-%s.php", $mode, $content['action']);
				if (isFileReadable($INC)) {
					// Load include file
					if ((!isExtensionActive($content['action'])) || ($content['action'] == 'online')) $GLOBALS['rows'] .= loadTemplate('menu_what_begin', true, $mode);
					//* DEBUG: */ debugOutput(__LINE__.'/'.$main_cnt.'/'.$content['action'].'/'.getWhat().'*');
					loadInclude($INC);
					//* DEBUG: */ debugOutput(__LINE__.'/'.$main_cnt.'/'.$content['action'].'/'.getWhat().'*');
					if ((!isExtensionActive($content['action'])) || ($content['action'] == 'online')) $GLOBALS['rows'] .= loadTemplate('menu_what_end', true, $mode);
				}
				//* DEBUG: */ debugOutput(__LINE__.'/'.$main_cnt.'/'.$content['action'].'/'.$content['sub_what'].':'.getWhat().'*');
			}

			// Free result
			SQL_FREERESULT($result_sub);

			// Count one up
			$main_cnt++;

			//* DEBUG: */ debugOutput(__LINE__.'/'.$main_cnt.':'.getWhat().'*');
			if (SQL_NUMROWS($result_main) > $main_cnt) {
				// Add seperator
				$GLOBALS['rows'] .= loadTemplate('menu_seperator', true, $mode);

				// Should we display adverts in this menu?
				if ((isExtensionInstalledAndNewer('menu', '0.0.1')) && (getConfig($mode . '_menu_advert_enabled') == 'Y') && ($action != 'admin')) {
					// Display advert template
					$GLOBALS['rows'] .= loadTemplate('menu_' . $mode . '_advert_' . $action, true);

					// Add seperator again
					$GLOBALS['rows'] .= loadTemplate('menu_seperator', true, $mode);
				} // END - if
			} // END - if
		} // END - while

		// Free memory
		SQL_FREERESULT($result_main);

		// Should we display adverts in this menu?
		if ((isExtensionInstalledAndNewer('menu', '0.0.1')) && (getConfig($mode . '_menu_advert_enabled') == 'Y')) {
			// Add seperator again
			$GLOBALS['rows'] .= loadTemplate('menu_seperator', true, $mode);

			// Display advert template
			$GLOBALS['rows'] .= loadTemplate('menu_' . $mode . '_advert_end', true);
		} // END - if

		// Prepare data
		$content = array(
			'rows' => $GLOBALS['rows'],
			'mode' => $mode
		);

		// Load main template
		//* DEBUG: */ debugOutput(__LINE__.'/'.$main_cnt.'/'.$content['action'].'/'.$content['sub_what'].':'.getWhat().'*');
		loadTemplate('menu_table', false, $content);
	} // END - if
}

// Checks wether the current user is a member
function isMember () {
	// By default no member
	$ret = false;

	// Fix missing 'last_online' array, damn stupid code :(((
	// @TODO Try to rewrite this to one or more functions
	if ((!isset($GLOBALS['last_online'])) || (!is_array($GLOBALS['last_online']))) $GLOBALS['last_online'] = array();

	// Is the cache entry there?
	if (isset($GLOBALS[__FUNCTION__])) {
		// Then return it
		//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'CACHED! (' . intval($GLOBALS[__FUNCTION__]) . ')');
		return $GLOBALS[__FUNCTION__];
	} elseif ((!isSessionVariableSet('userid')) || (!isSessionVariableSet('u_hash'))) {
		// Destroy any existing user session data
		destroyMemberSession();
		//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'No member set in cookie/session.');

		// Abort further processing
		return false;
	}

	// Get userid secured from session
	setMemberId(getSession('userid'));

	// ... and set it as currently handled user id
	setCurrentUserId(getMemberId());

	// Init user data array
	initUserData();

	// Fix "deleted" cookies first
	fixDeletedCookies(array('userid', 'u_hash'));

	// Are cookies set and can the member data be loaded?
	if ((isMemberIdSet()) && (isSessionVariableSet('u_hash')) && (fetchUserData(getMemberId()) === true)) {
		// Validate password by created the difference of it and the secret key
		$valPass = encodeHashForCookie(getUserData('password'));

		// So did we now have valid data and an unlocked user?
		if ((getUserData('status') == 'CONFIRMED') && ($valPass == getSession('u_hash'))) {
			// Transfer last module and online time
			$GLOBALS['last_online']['module'] = getUserData('last_module');
			$GLOBALS['last_online']['online'] = getUserData('last_online');

			// Account is confirmed and all cookie data is valid so he is definely logged in! :-)
			$ret = true;
		} // END - if
	} // END - if

	// Is $ret still false?
	if ($ret === false) {
		// Yes, so destroy the session
		destroyMemberSession();
	} // END - if

	// Cache status
	$GLOBALS[__FUNCTION__] = $ret;

	// Return status
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'ret=' . intval($ret));
	return $ret;
}

// Fetch user data for given user id
function fetchUserData ($userid, $column = 'userid') {
	// If we should look for userid secure&set it here
	if (substr($column, -2, 2) == 'id') {
		// Secure userid
		$userid = bigintval($userid);

		// Set it here
		setCurrentUserId($userid);

		// Don't look for invalid userids...
		if (!isValidUserId($userid)) {
			// Invalid, so abort here
			debug_report_bug(__FUNCTION__, __LINE__, 'User id ' . $userid . ' is invalid.');
		} elseif (isUserDataValid()) {
			// Use cache, so it is fine
			return true;
		}
	} elseif (isUserDataValid()) {
		// Use cache, so it is fine
		return true;
	}

	// By default none was found
	$found = false;

	// Extra statements
	$ADD = '';
	if (isExtensionInstalledAndNewer('user', '0.3.5')) $ADD = ', UNIX_TIMESTAMP(`lock_timestamp`) AS `lock_timestamp`';

	// Query for the user
	$result = SQL_QUERY_ESC("SELECT *".$ADD." FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `%s`='%s' LIMIT 1",
		array($column, $userid), __FUNCTION__, __LINE__);

	// Do we have a record?
	if (SQL_NUMROWS($result) == 1) {
		// Load data from cookies
		$data = SQL_FETCHARRAY($result);

		// Set the userid for later use
		setCurrentUserId($data['userid']);
		$GLOBALS['user_data'][getCurrentUserId()] = $data;

		// Rewrite 'last_failure' if found
		if (isset($GLOBALS['user_data'][getCurrentUserId()]['last_failure'])) {
			// Backup the raw one and zero it
			$GLOBALS['user_data'][getCurrentUserId()]['last_failure_raw'] = $GLOBALS['user_data'][getCurrentUserId()]['last_failure'];
			$GLOBALS['user_data'][getCurrentUserId()]['last_failure'] = '0';

			// Is it not zero?
			if ($GLOBALS['user_data'][getCurrentUserId()]['last_failure_raw'] != '0000-00-00 00:00:00') {
				// Seperate data/time
				$array = explode(' ', $GLOBALS['user_data'][getCurrentUserId()]['last_failure_raw']);

				// Seperate data and time again
				$array['date'] = explode('-', $array[0]);
				$array['time'] = explode(':', $array[1]);

				// Now pass it to mktime()
				$GLOBALS['user_data'][getCurrentUserId()]['last_failure'] = mktime(
					$array['time'][0],
					$array['time'][1],
					$array['time'][2],
					$array['date'][1],
					$array['date'][2],
					$array['date'][0]
				);
			} // END - if
		} // END - if

		// Found, but valid?
		$found = isUserDataValid();
	} // END - if

	// Free memory
	SQL_FREERESULT($result);

	// Return result
	return $found;
}

// This patched function will reduce many SELECT queries for the specified or current admin login
function isAdmin () {
	// No admin in installation phase!
	if ((isInstallationPhase()) || (!isAdminRegistered())) {
		return false;
	} // END - if

	// Init variables
	$ret = false;
	$adminId = '0';
	$passCookie = '';
	$valPass = '';
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, $adminId);

	// If admin login is not given take current from cookies...
	if ((isSessionVariableSet('admin_id')) && (isSessionVariableSet('admin_md5'))) {
		// Get admin login and password from session/cookies
		$adminId    = getSession('admin_id');
		$passCookie = getSession('admin_md5');
	} // END - if
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, $adminId.'/'.$passCookie);

	// Abort if admin id is zero
	if ($adminId == '0') {
		return false;
	} // END - if

	// Do we have cache?
	if (!isset($GLOBALS[__FUNCTION__][$adminId])) {
		// Init it with failed
		$GLOBALS[__FUNCTION__][$adminId] = false;

		// Search in array for entry
		if (isset($GLOBALS['admin_hash'])) {
			// Use cached string
			$valPass = $GLOBALS['admin_hash'];
		} elseif ((!empty($passCookie)) && (isAdminHashSet($adminId) === true) && (!empty($adminId))) {
			// Login data is valid or not?
			$valPass = encodeHashForCookie(getAdminHash($adminId));

			// Cache it away
			$GLOBALS['admin_hash'] = $valPass;

			// Count cache hits
			incrementStatsEntry('cache_hits');
		} elseif ((!empty($adminId)) && ((!isExtensionActive('cache')) || (isAdminHashSet($adminId) === false))) {
			// Get admin hash and hash it
			$valPass = encodeHashForCookie(getAdminHash($adminId));

			// Cache it away
			$GLOBALS['admin_hash'] = $valPass;
		}

		if (!empty($valPass)) {
			// Check if password is valid
			//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, '(' . $valPass . '==' . $passCookie . ')='.intval($valPass == $passCookie));
			$GLOBALS[__FUNCTION__][$adminId] = (($GLOBALS['admin_hash'] == $passCookie) || ((strlen($GLOBALS['admin_hash']) == 32) && ($GLOBALS['admin_hash'] == md5($passCookie))) || (($GLOBALS['admin_hash'] == '*FAILED*') && (!isExtensionActive('cache'))));
		} // END - if
	} // END - if

	// Return result of comparision
	return $GLOBALS[__FUNCTION__][$adminId];
}

// Generates a list of "max receiveable emails per day"
function addMaxReceiveList ($mode, $default = '', $return = false) {
	$OUT = '';
	$result = false;

	switch ($mode) {
		case 'guest':
			// Guests (in the registration form) are not allowed to select 0 mails per day.
			$result = SQL_QUERY('SELECT `value`, `comment` FROM `{?_MYSQL_PREFIX?}_max_receive` WHERE `value` > 0 ORDER BY `value` ASC',
			__FUNCTION__, __LINE__);
			break;

		case 'member':
			// Members are allowed to set to zero mails per day (we will change this soon!)
			$result = SQL_QUERY('SELECT `value`, `comment` FROM `{?_MYSQL_PREFIX?}_max_receive` ORDER BY `value` ASC',
			__FUNCTION__, __LINE__);
			break;

		default: // Invalid!
			logDebugMessage(__FUNCTION__, __LINE__, sprintf("Invalid mode %s detected.", $mode));
			break;
	}

	// Some entries are found?
	if (!SQL_HASZERONUMS($result)) {
		$OUT = '';
		while ($content = SQL_FETCHARRAY($result)) {
			$OUT .= '      <option value="' . $content['value'] . '"';
			if (postRequestParameter('max_mails') == $content['value']) $OUT .= ' selected="selected"';
			$OUT .= '>' . $content['value'] . ' {--PER_DAY--}';
			if (!empty($content['comment'])) $OUT .= '(' . $content['comment'] . ')';
			$OUT .= '</option>';
		}

		// Load template
		$OUT = loadTemplate(($mode . '_receive_table'), true, $OUT);
	} else {
		// Maybe the admin has to setup some maximum values?
		debug_report_bug(__FUNCTION__, __LINE__, 'Nothing is being done here?');
	}

	// Free result
	SQL_FREERESULT($result);

	if ($return === true) {
		// Return generated HTML code
		return $OUT;
	} else {
		// Output directly (default)
		outputHtml($OUT);
	}
}

// Checks wether the given email address is used.
function isEmailTaken ($email) {
	// Query the database
	$result = SQL_QUERY_ESC("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `email` LIKE '%%%s%%' OR `email` LIKE '%%%s%%' LIMIT 1",
		array($email, str_replace('.', '{DOT}', $email)), __FUNCTION__, __LINE__);

	// Is the email there?
	$ret = (SQL_NUMROWS($result) == 1);

	// Free the result
	SQL_FREERESULT($result);

	// Return result
	return $ret;
}

// Validate the given menu action
function isMenuActionValid ($mode, $action, $what, $updateEntry=false) {
	// Is the cache entry there and we shall not update?
	if ((isset($GLOBALS['action_valid'][$mode][$action][$what])) && ($updateEntry === false)) {
		// Count cache hit
		incrementStatsEntry('cache_hits');

		// Then use this cache
		return $GLOBALS['action_valid'][$mode][$action][$what];
	} // END - if

	// By default nothing is valid
	$ret = false;

	// Look in all menus or only unlocked
	$add = '';
	if ((!isAdmin()) && ($mode != 'admin')) $add = " AND `locked`='N'";

	//* DEBUG: */ debugOutput(__LINE__.':'.$mode.'/'.$action.'/'.$what.'*');
	if (($mode != 'admin') && ($updateEntry === true)) {
		// Update guest or member menu
		$sql = SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_%s_menu` SET counter=counter+1 WHERE `action`='%s' AND `what`='%s'".$add." LIMIT 1",
			array(
				$mode,
				$action,
				$what
			), __FUNCTION__, __LINE__, false);
	} elseif (($what != 'overview') && (!empty($what))) {
		// Other actions
		$sql = SQL_QUERY_ESC("SELECT `id`, `what` FROM `{?_MYSQL_PREFIX?}_%s_menu` WHERE `action`='%s' AND `what`='%s'".$add." ORDER BY `action` DESC LIMIT 1",
			array(
				$mode,
				$action,
				$what
			), __FUNCTION__, __LINE__, false);
	} else {
		// Admin login overview
		$sql = SQL_QUERY_ESC("SELECT `id`, `what` FROM `{?_MYSQL_PREFIX?}_%s_menu` WHERE `action`='%s' AND (`what`='' OR `what` IS NULL)".$add." ORDER BY `action` DESC LIMIT 1",
			array(
				$mode,
				$action
			), __FUNCTION__, __LINE__, false);
	}

	// Run SQL command
	$result = SQL_QUERY($sql, __FUNCTION__, __LINE__);

	// Should we look for affected rows (only update) or found rows?
	if ($updateEntry === true) {
		// Check updated/affected rows
		$ret = (!SQL_HASZEROAFFECTED());
	} else {
		// Check found rows
		$ret = (!SQL_HASZERONUMS($result));
	}

	// Free memory
	SQL_FREERESULT($result);

	// Set cache entry
	$GLOBALS['action_valid'][$mode][$action][$what] = $ret;

	// Return result
	return $ret;
}

// Get action value from mode (admin/guest/member) and what-value
function getActionFromModuleWhat ($module, $what) {
	// Init status
	$data['action'] = '';

	//* DEBUG: */ debugOutput(__LINE__ . '=' . $module . '/'.$what . '/' . getAction() . '=');
	if (!isExtensionInstalledAndNewer('sql_patches', '0.0.5')) {
		// sql_patches is missing so choose depending on mode
		if (isWhatSet()) {
			// Use setted what
			$what = getWhat();
		} elseif ($module == 'admin') {
			// Admin area
			$what = 'overview';
		} else {
			// Everywhere else
			$what = 'welcome';
		}
	} elseif ((empty($what)) && ($module != 'admin')) {
		// Use configured 'home'
		$what = getIndexHome();
	} // END - if

	if ($module == 'admin') {
		// Action value for admin area
		if (isGetRequestParameterSet('action')) {
			// Use from request!
			return getRequestParameter('action');
		} elseif (isActionSet()) {
			// Get it directly from URL
			return getAction();
		} elseif (($what == 'overview') || (!isWhatSet())) {
			// Default value for admin area
			$data['action'] = 'login';
		}
	} elseif (isActionSet()) {
		// Get it directly from URL
		return getAction();
	}
	//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>): ret=' . $data['action']);

	// Does the module have a menu?
	if (ifModuleHasMenu($module)) {
		// Rewriting modules to menu
		$module = mapModuleToTable($module);

		// Guest and member menu is 'main' as the default
		if (empty($data['action'])) $data['action'] = 'main';

		// Load from database
		$result = SQL_QUERY_ESC("SELECT `action` FROM `{?_MYSQL_PREFIX?}_%s_menu` WHERE `what`='%s' LIMIT 1",
			array($module, $what), __FUNCTION__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Load action value and pray that this one is the right you want... ;-)
			$data = SQL_FETCHARRAY($result);
		} // END - if

		// Free memory
		SQL_FREERESULT($result);
	} elseif ((!isExtensionInstalled('sql_patches')) && ($module != 'admin') && ($module != 'unknown')) {
		// No sql_patches installed, but maybe we need to register an admin?
		if (isAdminRegistered()) {
			// Redirect to admin area
			redirectToUrl('admin.php');
		} // END - if
	}

	// Return action value
	return $data['action'];
}

// Get category name back
function getCategory ($cid) {
	// Default is not found
	$data['cat'] = '{--_CATEGORY_404--}';

	// Is the category id set?
	if ($cid == '0') {
		// No category
		$data['cat'] = '{--_CATEGORY_NONE--}';
	} elseif ($cid > 0) {
		// Lookup the category in database
		$result = SQL_QUERY_ESC("SELECT `cat` FROM `{?_MYSQL_PREFIX?}_cats` WHERE `id`=%s LIMIT 1",
			array(bigintval($cid)), __FUNCTION__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Category found... :-)
			$data = SQL_FETCHARRAY($result);
		} // END - if

		// Free result
		SQL_FREERESULT($result);
	} // END - if

	// Return result
	return $data['cat'];
}

// Get a string of "mail title" and price back
function getPaymentTitlePrice ($pid, $full=false) {
	// Default is not found
	$ret = '{--_PAYMENT_404--}';

	// Load payment data
	$result = SQL_QUERY_ESC("SELECT `mail_title`, `price` FROM `{?_MYSQL_PREFIX?}_payments` WHERE `id`=%s LIMIT 1",
		array(bigintval($pid)), __FUNCTION__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Payment type found... :-)
		$data = SQL_FETCHARRAY($result);

		// Only title or also including price?
		if ($full === false) {
			$ret = $data['mail_title'];
		} else {
			$ret = $data['mail_title'] . ' / {%pipe,translateComma=' . $data['price'] . '%} {?POINTS?}';
		}
	}

	// Free result
	SQL_FREERESULT($result);

	// Return result
	return $ret;
}

// Get (basicly) the price of given payment id
function getPaymentPoints ($pid, $lookFor = 'price') {
	// Default value...
	$data[$lookFor] = '-1';

	// Search for it in database
	$result = SQL_QUERY_ESC("SELECT `%s` FROM `{?_MYSQL_PREFIX?}_payments` WHERE `id`=%s LIMIT 1",
		array($lookFor, $pid), __FUNCTION__, __LINE__);

	// Is the entry there?
	if (SQL_NUMROWS($result) == 1) {
		// Payment type found... :-)
		$data = SQL_FETCHARRAY($result);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return value
	return $data[$lookFor];
}

// Remove a receiver's id from $receivers and add a link for him to confirm
function removeReceiver (&$receivers, $key, $userid, $pool_id, $stats_id = '', $bonus = false) {
	// Default is not removed
	$ret = 'failed';

	// Is the userid valid?
	if (isValidUserId($userid)) {
		// Remove entry from array
		unset($receivers[$key]);

		// Is there already a line for this user available?
		if ($stats_id > 0) {
			// Only when we got a real stats id continue searching for the entry
			$type = 'NORMAL'; $rowName = 'stats_id';
			if ($bonus) {
				$type = 'BONUS';
				$rowName = 'bonus_id';
			} // END - if

			// Try to look the entry up
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE %s='%s' AND `userid`=%s AND link_type='%s' LIMIT 1",
				array($rowName, $stats_id, bigintval($userid), $type), __FUNCTION__, __LINE__);

			// Was it *not* found?
			if (SQL_HASZERONUMS($result)) {
				// So we add one!
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_links` (`%s`, `userid`, `link_type`) VALUES ('%s','%s','%s')",
					array($rowName, $stats_id, bigintval($userid), $type), __FUNCTION__, __LINE__);
				$ret = 'done';
			} else {
				// Already found
				$ret = 'already';
			}

			// Free memory
			SQL_FREERESULT($result);
		} // END - if
	} // END - if

	// Return status for sending routine
	return $ret;
}

// Calculate sum (default) or count records of given criteria
function countSumTotalData ($search, $tableName, $lookFor = 'id', $whereStatement = 'userid', $countRows = false, $add = '') {
	// Init count/sum
	$data['res'] = '0';

	//* DEBUG: */ debugOutput($search.'/'.$tableName.'/'.$lookFor.'/'.$whereStatement.'/'.$add);
	if ((empty($search)) && ($search != '0')) {
		// Count or sum whole table?
		if ($countRows === true) {
			// Count whole table
			$result = SQL_QUERY_ESC("SELECT COUNT(`%s`) AS `res` FROM `{?_MYSQL_PREFIX?}_%s`".$add,
				array($lookFor, $tableName), __FUNCTION__, __LINE__);
		} else {
			// Sum whole table
			$result = SQL_QUERY_ESC("SELECT SUM(`%s`) AS `res` FROM `{?_MYSQL_PREFIX?}_%s`".$add,
				array($lookFor, $tableName), __FUNCTION__, __LINE__);
		}
	} elseif (($countRows === true) || ($lookFor == 'userid')) {
		// Count rows
		//* DEBUG: */ debugOutput('COUNT!');
		$result = SQL_QUERY_ESC("SELECT COUNT(`%s`) AS `res` FROM `{?_MYSQL_PREFIX?}_%s` WHERE `%s`='%s'".$add,
			array($lookFor, $tableName, $whereStatement, $search), __FUNCTION__, __LINE__);
	} else {
		// Add all rows
		//* DEBUG: */ debugOutput('SUM!');
		$result = SQL_QUERY_ESC("SELECT SUM(`%s`) AS `res` FROM `{?_MYSQL_PREFIX?}_%s` WHERE `%s`='%s'".$add,
			array($lookFor, $tableName, $whereStatement, $search), __FUNCTION__, __LINE__);
	}

	// Load row
	$data = SQL_FETCHARRAY($result);

	// Free result
	SQL_FREERESULT($result);

	// Fix empty values
	if ((empty($data['res'])) && ($lookFor != 'counter') && ($lookFor != 'id') && ($lookFor != 'userid')) {
		// Float number
		$data['res'] = '0.00000';
	} elseif (''.$data['res'].'' == '') {
		// Fix empty result
		$data['res'] = '0';
	}

	// Return value
	//* DEBUG: */ debugOutput('ret=' . $data['res']);
	return $data['res'];
}
// Getter fro ref level percents
function getReferalLevelPercents ($level) {
	// Default is zero
	$data['percents'] = '0';

	// Do we have cache?
	if ((isset($GLOBALS['cache_array']['refdepths']['level'])) && (isExtensionActive('cache'))) {
		// First look for level
		$key = array_search($level, $GLOBALS['cache_array']['refdepths']['level']);
		if ($key !== false) {
			// Entry found!
			$data['percents'] = $GLOBALS['cache_array']['refdepths']['percents'][$key];

			// Count cache hit
			incrementStatsEntry('cache_hits');
		} // END - if
	} elseif (!isExtensionActive('cache')) {
		// Get referal data
		$result_level = SQL_QUERY_ESC("SELECT `percents` FROM `{?_MYSQL_PREFIX?}_refdepths` WHERE `level`='%s' LIMIT 1",
			array(bigintval($level)), __FUNCTION__, __LINE__);

		// Entry found?
		if (SQL_NUMROWS($result_level) == 1) {
			// Get percents
			$data = SQL_FETCHARRAY($result_level);
		} // END - if

		// Free result
		SQL_FREERESULT($result_level);
	}

	// Return percent
	return $data['percents'];
}

/**
 *
 * Dynamic referal system, can also send mails!
 *
 * subject     = Subject line, write in lower-case letters and underscore is allowed
 * userid      = Referal id wich should receive...
 * points      = ... xxx points
 * sendNotify  = shall I send the referal an email or not?
 * refid       = inc/modules/guest/what-confirm.php need this
 * locked      = Shall I pay it to normal (false) or locked (true) points ammount?
 * add_mode    = Add points only to $userid or also refs? (WARNING! Changing 'ref' to 'direct'
 *               for default value will cause no referal will get points ever!!!)
 */
function addPointsThroughReferalSystem ($subject, $userid, $points, $sendNotify = false, $refid = '0', $add_mode = 'ref') {
	// By default nothing has been added
	$added = false;

	//* DEBUG: */ debugOutput('----------------------- <font color="#00aa00">' . __FUNCTION__ . ' - ENTRY</font> ------------------------<ul><li>');
	// Convert mode to lower-case
	$add_mode = strtolower($add_mode);

	// When $userid = '0' add points to jackpot
	if (($userid == '0') && (isExtensionActive('jackpot'))) {
		// Add points to jackpot
		addPointsToJackpot($points);
		return;
	} // END - if

	// Count up referal depth
	if (!isset($GLOBALS['ref_level'])) {
		// Initialialize referal system
		//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>): Referal system initialized!');
		$GLOBALS['ref_level'] = '0';
	} else {
		// Increase referal level
		$GLOBALS['ref_level']++;
		//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>): Referal level increased. DEPTH='.$GLOBALS['ref_level']);
	}

	// Check user account
	//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid.',points='.$points);
	if (fetchUserData($userid)) {
		// Determine wether the user has some mails to click before he/she gets the points
		$locked = ifUserPointsLocked($userid);

		// Default is 'normal' points
		$data = 'points';

		// Which points, locked or normal?
		if ($locked === true) {
			$data = 'locked_points';
		} // END - if

		// This is the user and his ref
		$GLOBALS['cache_array']['add_userid'][getUserData('refid')] = $userid;

		// Get percents
		$per = getReferalLevelPercents($GLOBALS['ref_level']);
		//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid.',points='.$points.',depth='.$GLOBALS['ref_level'].',per='.$per.',mode='.$add_mode);

		// Some percents found?
		if ($per > 0) {
			// Calculate new points
			//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid.',points='.$points.',per='.$per.',depth='.$GLOBALS['ref_level']);
			$ref_points = $points * $per / 100;

			// Pay refback here if level > 0 and in ref-mode
			if ((isExtensionActive('refback')) && ($GLOBALS['ref_level'] > 0) && ($per < 100) && ($add_mode == 'ref') && (isset($GLOBALS['cache_array']['add_userid'][$userid]))) {
				//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid.',data='.$GLOBALS['cache_array']['add_userid'][$userid].',ref_points='.$ref_points.',depth='.$GLOBALS['ref_level'].' - BEFORE!');
				$ref_points = addRefbackPoints($GLOBALS['cache_array']['add_userid'][$userid], $userid, $points, $ref_points);
				//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid.',data='.$GLOBALS['cache_array']['add_userid'][$userid].',ref_points='.$ref_points.',depth='.$GLOBALS['ref_level'].' - AFTER!');
			} // END - if

			// Update points...
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_points` SET `%s`=`%s`+%s WHERE `userid`=%s AND `ref_depth`=%s LIMIT 1",
				array($data, $data, $ref_points, bigintval($userid), bigintval($GLOBALS['ref_level'])), __FUNCTION__, __LINE__);
			//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):data='.$data.',ref_points='.$ref_points.',userid='.$userid.',depth='.$GLOBALS['ref_level'].',mode='.$add_mode.' - UPDATE! ('.SQL_AFFECTEDROWS().')');

			// No entry updated?
			if (SQL_HASZEROAFFECTED()) {
				// First ref in this level! :-)
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_points` (`userid`,`ref_depth`,`%s`) VALUES (%s,%s,%s)",
					array($data, bigintval($userid), bigintval($GLOBALS['ref_level']), $ref_points), __FUNCTION__, __LINE__);
				//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):data='.$data.',ref_points='.$ref_points.',userid='.$userid.',depth='.$GLOBALS['ref_level'].',mode='.$add_mode.' - INSERTED! ('.SQL_AFFECTEDROWS().')');
			} // END - if

			// Check affected rows
			$added = SQL_AFFECTEDROWS();
			//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):added='.intval($added));

			// Prepare data for the filter
			$filterData = array(
				'subject'  => $subject,
				'userid'   => $userid,
				'points'   => $points,
				'notify'   => $sendNotify,
				'refid'    => $refid,
				'locked'   => $locked,
				'mode'     => 'add',
				'sub_mode' => $add_mode,
				'added'    => $added
			);

			// Filter it now
			$filterData = runFilterChain('add_points', $filterData);

			// Extract $added
			$added = $filterData['added'];
			//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):added='.intval($added));

			// Points updated, maybe I shall send him an email?
			if (($sendNotify === true) && (isValidUserId(getUserData('refid'))) && ($locked === false)) {
				// Prepare content
				$content = array(
					'percents' => $per,
					'level'    => bigintval($GLOBALS['ref_level']),
					'points'   => $ref_points,
				);

				// Load email template
				$message = loadEmailTemplate('confirm-referal', $content, bigintval($userid));

				// Send email
				sendEmail($userid, '{--THANX_REFERAL_ONE_SUBJECT--}', $message);
			} elseif (($sendNotify === true) && (!isValidUserId(getUserData('refid'))) && ($locked === false) && ($add_mode == 'direct')) {
				// Prepare content
				$content = array(
					'reason' => '{--REASON_DIRECT_PAYMENT--}',
					'points' => $ref_points
				);

				// Load message
				$message = loadEmailTemplate('add-points', $content, $userid);

				// And sent it away
				sendEmail($userid, '{--DIRECT_PAYMENT_SUBJECT--}', $message);
				if (!isGetRequestParameterSet('mid')) {
					// Output message to admin
					loadTemplate('admin_settings_saved', false, '{--ADMIN_POINTS_ADDED--}');
				} // END - if
			}

			// Maybe there's another ref?
			if ((isValidUserId(getUserData('refid'))) && ($points > 0) && (getUserData('refid') != $userid) && ($add_mode == 'ref')) {
				// Then let's credit him here...
				//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid.',ref='.getUserData('refid').',points='.$points.' - ADVANCE!');
				$added = ($added && addPointsThroughReferalSystem(sprintf("%s_ref:%s", $subject, $GLOBALS['ref_level']), getUserData('refid'), $points, $sendNotify, getUserData('refid')));
			} // END - if
		} // END - if
	} // END - if

	//* DEBUG: */ debugOutput('</li></ul>----------------------- <font color="#aa0000">'.__FUNCTION__.': added=' . intval($added) . ' - EXIT</font> ------------------------<br />');
	return $added;
}

// Updates the referal counter
function updateReferalCounter ($userid) {
	// Make it sure referal level zero (member him-/herself) is at least selected
	if (empty($GLOBALS['cache_array']['ref_level'][$userid])) $GLOBALS['cache_array']['ref_level'][$userid] = 1;
	//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid.',level='.$GLOBALS['cache_array']['ref_level'][$userid]);

	// Update counter
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_refsystem` SET `counter`=`counter`+1 WHERE `userid`=%s AND `level`='%s' LIMIT 1",
		array(bigintval($userid), $GLOBALS['cache_array']['ref_level'][$userid]), __FUNCTION__, __LINE__);

	// When no entry was updated then we have to create it here
	//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):updated=' . SQL_AFFECTEDROWS());
	if (SQL_HASZEROAFFECTED()) {
		// First count!
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_refsystem` (`userid`, `level`, `counter`) VALUES (%s,%s,1)",
			array(
				bigintval($userid),
				$GLOBALS['cache_array']['ref_level'][$userid]
			), __FUNCTION__, __LINE__);
		//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid);
	} // END - if

	// Init referal id
	$ref = '0';

	// Check for his referal
	if (fetchUserData($userid)) {
		// Get it
		$ref = getUserData('refid');
	} // END - if

	//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):userid='.$userid.',ref='.$ref);

	// When he has a referal...
	if (($ref > 0) && ($ref != $userid)) {
		// Move to next referal level and count his counter one up!
		//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):ref='.$ref.' - ADVANCE!');
		$GLOBALS['cache_array']['ref_level'][$userid]++;
		updateReferalCounter($ref);
	} elseif ((($ref == $userid) || ($ref == '0')) && (isExtensionInstalledAndNewer('cache', '0.1.2'))) {
		// Remove cache here
		//* DEBUG: */ debugOutput(__FUNCTION__ . '(<font color="#0000aa">' . __LINE__ . '</font>):ref='.$ref.' - CACHE!');
		rebuildCache('refsystem', 'refsystem');
	}

	// "Walk" back here
	$GLOBALS['cache_array']['ref_level'][$userid]--;

	// Handle refback here if extension is installed
	// @TODO Rewrite this to a filter
	if (isExtensionActive('refback')) {
		updateRefbackTable($userid);
	} // END - if
}

// Sends out mail to all administrators. This function is no longer obsolete
// because we need it when there is no ext-admins installed
function sendAdminEmails ($subj, $message) {
	// Load all admin email addresses
	$result = SQL_QUERY('SELECT `email` FROM `{?_MYSQL_PREFIX?}_admins` ORDER BY `id` ASC', __FUNCTION__, __LINE__);
	while ($content = SQL_FETCHARRAY($result)) {
		// Send the email out
		sendEmail($content['email'], $subj, $message);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Really simple... ;-)
}

// Get id number from administrator's login name
function getAdminId ($adminLogin) {
	// By default no admin is found
	$data['id'] = '-1';

	// Check cache
	if (isset($GLOBALS['cache_array']['admin']['admin_id'][$adminLogin])) {
		// Use it if found to save SQL queries
		$data['id'] = $GLOBALS['cache_array']['admin']['admin_id'][$adminLogin];

		// Update cache hits
		incrementStatsEntry('cache_hits');
	} elseif (!isExtensionActive('cache')) {
		// Load from database
		$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `login`='%s' LIMIT 1",
			array($adminLogin), __FUNCTION__, __LINE__);

		// Do we have an entry?
		if (SQL_NUMROWS($result) == 1) {
			// Get it
			$data = SQL_FETCHARRAY($result);
		} // END - if

		// Free result
		SQL_FREERESULT($result);
	}

	// Return the id
	return $data['id'];
}

// "Getter" for current admin id
function getCurrentAdminId () {
	// Do we have cache?
	if (!isset($GLOBALS['current_admin_id'])) {
		// Get the admin login from session
		$adminId = getSession('admin_id');

		// Remember in cache securely
		setCurrentAdminId(bigintval($adminId));
	} // END - if

	// Return it
	return $GLOBALS['current_admin_id'];
}

// Setter for current admin id
function setCurrentAdminId ($currentAdminId) {
	// Set it secured
	$GLOBALS['current_admin_id'] = bigintval($currentAdminId);
}

// Get password hash from administrator's login name
function getAdminHash ($adminId) {
	// By default an invalid hash is returned
	$data['password'] = '-1';

	if (isAdminHashSet($adminId)) {
		// Check cache
		$data['password'] = $GLOBALS['cache_array']['admin']['password'][$adminId];

		// Update cache hits
		incrementStatsEntry('cache_hits');
	} elseif (!isExtensionActive('cache')) {
		// Load from database
		$result = SQL_QUERY_ESC("SELECT `password` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
			array(bigintval($adminId)), __FUNCTION__, __LINE__);

		// Do we have an entry?
		if (SQL_NUMROWS($result) == 1) {
			// Fetch data
			$data = SQL_FETCHARRAY($result);

			// Set cache
			setAdminHash($adminId, $data['password']);
		} // END - if

		// Free result
		SQL_FREERESULT($result);
	}

	// Return password hash
	return $data['password'];
}

// "Getter" for admin login
function getAdminLogin ($adminId) {
	// By default a non-existent login is returned (other functions react on this!)
	$data['login'] = '***';

	if (isset($GLOBALS['cache_array']['admin']['login'][$adminId])) {
		// Get cache
		$data['login'] = $GLOBALS['cache_array']['admin']['login'][$adminId];

		// Update cache hits
		incrementStatsEntry('cache_hits');
	} elseif (!isExtensionActive('cache')) {
		// Load from database
		$result = SQL_QUERY_ESC("SELECT `login` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
			array(bigintval($adminId)), __FUNCTION__, __LINE__);

		// Entry found?
		if (SQL_NUMROWS($result) == 1) {
			// Fetch data
			$data = SQL_FETCHARRAY($result);

			// Set cache
			$GLOBALS['cache_array']['admin']['login'][$adminId] = $data['login'];
		} // END - if

		// Free memory
		SQL_FREERESULT($result);
	}

	// Return the result
	return $data['login'];
}

// Get email address of admin id
function getAdminEmail ($adminId) {
	// By default an invalid emails is returned
	$data['email'] = '***';

	if (isset($GLOBALS['cache_array']['admin']['email'][$adminId])) {
		// Get cache
		$data['email'] = $GLOBALS['cache_array']['admin']['email'][$adminId];

		// Update cache hits
		incrementStatsEntry('cache_hits');
	} elseif (!isExtensionActive('cache')) {
		// Load from database
		$result_admin_id = SQL_QUERY_ESC("SELECT `email` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
			array(bigintval($adminId)), __FUNCTION__, __LINE__);

		// Entry found?
		if (SQL_NUMROWS($result_admin_id) == 1) {
			// Get data
			$data = SQL_FETCHARRAY($result_admin_id);

			// Set cache
			$GLOBALS['cache_array']['admin']['email'][$adminId] = $data['email'];
		} // END - if

		// Free result
		SQL_FREERESULT($result_admin_id);
	}

	// Return email
	return $data['email'];
}

// Get default ACL  of admin id
function getAdminDefaultAcl ($adminId) {
	// By default an invalid ACL value is returned
	$data['default_acl'] = '***';

	// Is sql_patches there and was it found in cache?
	if (!isExtensionActive('sql_patches')) {
		// Not found, which is bad, so we need to allow all
		$data['default_acl'] =  'allow';
	} elseif (isset($GLOBALS['cache_array']['admin']['def_acl'][$adminId])) {
		// Use cache
		$data['default_acl'] = $GLOBALS['cache_array']['admin']['def_acl'][$adminId];

		// Update cache hits
		incrementStatsEntry('cache_hits');
	} elseif (!isExtensionActive('cache')) {
		// Load from database
		$result_admin_id = SQL_QUERY_ESC("SELECT `default_acl` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
			array(bigintval($adminId)), __FUNCTION__, __LINE__);
		if (SQL_NUMROWS($result_admin_id) == 1) {
			// Fetch data
			$data = SQL_FETCHARRAY($result_admin_id);

			// Set cache
			$GLOBALS['cache_array']['admin']['def_acl'][$adminId] = $data['default_acl'];
		}

		// Free result
		SQL_FREERESULT($result_admin_id);
	}

	// Return default ACL
	return $data['default_acl'];
}

// Generates an option list from various parameters
function generateOptionList ($table, $id, $name, $default = '', $special = '', $where = '', $disabled = array(), $callback = '') {
	$ret = '';
	if ($table == '/ARRAY/') {
		// Selection from array
		if ((is_array($id)) && (is_array($name)) && ((count($id)) == (count($name)) || (!empty($callback)))) {
			// Both are arrays
			foreach ($id as $idx => $value) {
				$ret .= '<option value="' . $value . '"';
				if ($default == $value) {
					// Selected by default
					$ret .= ' selected="selected"';
				} elseif (isset($disabled[$value])) {
					// Disabled!
					$ret .= ' disabled="disabled"';
				}

				// Is the call-back function set?
				if (!empty($callback)) {
					// Call it
					$name[$idx] = call_user_func_array($callback, array($id[$idx]));
				} // END - if

				// Finish option tag
				$ret .= '>' . $name[$idx] . '</option>';
			} // END - foreach
		} else {
			// Problem in request
			debug_report_bug(__FUNCTION__, __LINE__, 'Not all are arrays: id[' . count($id) . ']=' . gettype($id) . ',name[' . count($name) . ']=' . gettype($name) . ',callback=' . $callback);
		}
	} else {
		// Data from database
		$SPEC = ', `' . $id . '`';
		if (!empty($special)) $SPEC = ', `' . $special . '`';

		// Query the database
		$result = SQL_QUERY_ESC("SELECT `%s`, `%s`".$SPEC." FROM `{?_MYSQL_PREFIX?}_%s` ".$where." ORDER BY `%s` ASC",
			array(
				$id,
				$name,
				$table,
				$name
			), __FUNCTION__, __LINE__);

		// Do we have rows?
		if (!SQL_HASZERONUMS($result)) {
			// Found data so add them as OPTION lines: $id is the value and $name is the "name" of the option
			// @TODO Try to rewrite this to $content = SQL_FETCHARRAY()
			while (list($value, $title, $add) = SQL_FETCHROW($result)) {
				if (empty($special)) $add = '';
				$ret .= '<option value="' . $value . '"';
				if ($default == $value) {
					// Selected by default
					$ret .= ' selected="selected"';
				} elseif (isset($disabled[$value])) {
					// Disabled!
					$ret .= ' disabled="disabled"';
				}

				// Add it, if set
				if (!empty($add)) $add = ' ('.$add.')';

				// Is the call-back function set?
				if (!empty($callback)) {
					// Call it
					$title = call_user_func_array($callback, array($title));
				} // END - if

				// Finish option list
				$ret .= '>' . $title . $add . '</option>';
			} // END - while
		} else {
			// No data found
			$ret = '<option value="x">{--SELECT_NONE--}</option>';
		}

		// Free memory
		SQL_FREERESULT($result);
	}

	// Return - hopefully - the requested data
	return $ret;
}
// Activate exchange
function FILTER_ACTIVATE_EXCHANGE () {
	// Is the extension 'user' there?
	if ((!isExtensionActive('user')) || (getActivateXchange() == '0')) {
		// Silently abort here
		return false;
	} // END - if

	// Check total amount of users
	if (getTotalConfirmedUser() >= getActivateXchange()) {
		// Activate System
		addSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `locked`='N', `hidden`='N', `mem_only`='Y' WHERE `module`='order' LIMIT 1");
		addSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y', `locked`='N' WHERE `what`='order' OR `what`='unconfirmed' LIMIT 2");

		// Run SQLs
		runFilterChain('run_sqls');

		// Update configuration
		updateConfiguration('activate_xchange' ,0);

		// Rebuild cache
		rebuildCache('modules', 'modules');
	} // END - if
}

// Deletes a user account with given reason
function deleteUserAccount ($userid, $reason) {
	// Init points
	$data['points'] = '0';

	$result = SQL_QUERY_ESC("SELECT
	(SUM(p.`points`) - d.`used_points`) AS `points`
FROM
	`{?_MYSQL_PREFIX?}_user_points` AS p
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_data` AS d
ON
	p.`userid`=d.`userid`
WHERE
	p.`userid`=%s
LIMIT 1",
		array(bigintval($userid)), __FUNCTION__, __LINE__);

	// Do we have an entry?
	if (SQL_NUMROWS($result) == 1) {
		// Save his points to add them to the jackpot
		$data = SQL_FETCHARRAY($result);

		// Delete points entries as well
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_points` WHERE `userid`=%s",
			array(bigintval($userid)), __FUNCTION__, __LINE__);

		// Update mediadata as well
		if (isExtensionInstalledAndNewer('mediadata', '0.0.4')) {
			// Update database
			updateMediadataEntry(array('total_points'), 'sub', $data['points']);
		} // END - if

		// Now, when we have all his points adds them do the jackpot!
		if (isExtensionActive('jackpot')) addPointsToJackpot($data['points']);
	} // END - if

	// Free the result
	SQL_FREERESULT($result);

	// Delete category selections as well...
	SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_cats` WHERE `userid`=%s",
		array(bigintval($userid)), __FUNCTION__, __LINE__);

	// Remove from rallye if found
	// @TODO Rewrite this to a filter
	if (isExtensionActive('rallye')) {
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_rallye_users` WHERE `userid`=%s",
			array(bigintval($userid)), __FUNCTION__, __LINE__);
	} // END - if

	// Add reason and translate points
	$data['text']   = $reason;

	// Now a mail to the user and that's all...
	$message = loadEmailTemplate('del-user', $data, $userid);
	sendEmail($userid, '{--ADMIN_DELETE_ACCOUNT--}', $message);

	// Ok, delete the account!
	SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1", array(bigintval($userid)), __FUNCTION__, __LINE__);
}

// Gets the matching what name from module
function getWhatFromModule ($modCheck) {
	// Is the request element set?
	if (isGetRequestParameterSet('what')) {
		// Then return this!
		return getRequestParameter('what');
	} // END - if

	// Default is empty
	$what = '';

	//* DEBUG: */ debugOutput(__LINE__.'!'.$modCheck.'!');
	switch ($modCheck) {
		case 'admin':
			$what = 'overview';
			break;

		case 'login':
		case 'index':
			// Is ext-sql_patches installed and newer than 0.0.5?
			if (isExtensionInstalledAndNewer('sql_patches', '0.0.5')) {
				// Use it from config
				$what = getIndexHome();
			} else {
				// Use default 'welcome'
				$what = 'welcome';
			}
			break;

		default:
			$what = '';
			break;
	} // END - switch

	// Return what value
	return $what;
}

// Subtract points from database and mediadata cache
function subtractPoints ($subject, $userid, $points) {
	// Add points to used points
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `used_points`=`used_points`+%s WHERE `userid`=%s LIMIT 1",
		array($points, bigintval($userid)), __FUNCTION__, __LINE__);

	// Prepare filter data
	$filterData = array(
		'subject' => $subject,
		'userid'  => $userid,
		'points'  => $points,
		'mode'    => 'sub',
		'added'   => (!SQL_HASZEROAFFECTED())
	);

	// Insert booking record
	$filterData = runFilterChain('sub_points', $filterData);

	// Return result
	return $filterData['added'];
}

// "Getter" for total available receivers
function getTotalReceivers ($mode = 'normal') {
	// Get num rows
	$numRows = countSumTotalData('CONFIRMED', 'user_data', 'userid', 'status', true, ' AND `receive_mails` > 0' . runFilterChain('exclude_users', $mode));

	// Return value
	return $numRows;
}

// Returns HTML code with an option list of all categories
function generateCategoryOptionsList ($mode) {
	// Prepare WHERE statement
	$whereStatement = " WHERE `visible`='Y'";
	if (isAdmin()) $whereStatement = '';

	// Initialize array...
	$CATS = array(
		'id'   => array(),
		'name' => array(),
		'userids' => array()
	);

	// Get categories
	$result = SQL_QUERY('SELECT `id`, `cat` FROM `{?_MYSQL_PREFIX?}_cats`' . $whereStatement . ' ORDER BY `sort` ASC',
		__FUNCTION__, __LINE__);

	// Do we have entries?
	if (!SQL_HASZERONUMS($result)) {
		// ... and begin loading stuff
		while ($content = SQL_FETCHARRAY($result)) {
			// Transfer some data
			$CATS['id'][]   = $content['id'];
			$CATS['name'][] = $content['cat'];

			// Check which users are in this category
			$result_userids = SQL_QUERY_ESC("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_cats` WHERE `cat_id`=%s ORDER BY `userid` ASC",
				array(bigintval($content['id'])), __FUNCTION__, __LINE__);

			// Init count
			$userid_cnt = '0';

			// Start adding all
			while ($data = SQL_FETCHARRAY($result_userids)) {
				// Add user count
				$userid_cnt += countSumTotalData($data['userid'], 'user_data', 'userid', 'userid', true, " AND `status`='CONFIRMED' AND `receive_mails` > 0");
			} // END - while

			// Free memory
			SQL_FREERESULT($result_userids);

			// Add counter
			$CATS['userids'][] = $userid_cnt;
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Generate options
		$OUT = '';
		foreach ($CATS['id'] as $key => $value) {
			if (strlen($CATS['name'][$key]) > 20) $CATS['name'][$key] = substr($CATS['name'][$key], 0, 17)."...";
			$OUT .= '      <option value="' . $value . '">' . $CATS['name'][$key] . ' (' . $CATS['userids'][$key] . ' {--USER_IN_CAT--})</option>';
		} // END - foreach
	} else {
		// No cateogries are defined yet
		$OUT = '<option class="notice">{--MEMBER_NO_CATEGORIES--}</option>';
	}

	// Return HTML code
	return $OUT;
}

// Add bonus mail to queue
function addBonusMailToQueue ($subject, $text, $receiverList, $points, $seconds, $url, $cat, $mode='normal', $receiver=0) {
	// Is admin or bonus extension there?
	if (!isAdmin()) {
		// Abort here
		return false;
	} elseif (!isExtensionActive('bonus')) {
		// Abort here
		return false;
	}

	// Calculcate target sent
	$target = countSelection(explode(';', $receiverList));

	// Receiver is zero?
	if ($receiver == '0') {
		// Then auto-fix it
		$receiver = $target;
	} // END - if

	// HTML extension active?
	if (isExtensionActive('html_mail')) {
		// No HTML by default
		$HTML = 'N';

		// HTML mode?
		if ($mode == 'html') $HTML = 'Y';

		// Add HTML mail
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_bonus`
(`subject`, `text`, `receivers`, `points`, `time`, `data_type`, `timestamp`, `url`, `cat_id`, `target_send`, `mails_sent`, `html_msg`)
VALUES ('%s','%s','%s','%s','%s','NEW', UNIX_TIMESTAMP(),'%s','%s','%s','%s','%s')",
		array(
			$subject,
			$text,
			$receiverList,
			$points,
			$seconds,
			$url,
			$cat,
			$target,
			bigintval($receiver),
			$HTML
		), __FUNCTION__, __LINE__);
	} else {
		// Add regular mail
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_bonus`
(`subject`, `text`, `receivers`, `points`, `time`, `data_type`, `timestamp`, `url`, `cat_id`, `target_send`, `mails_sent`)
VALUES ('%s','%s','%s','%s','%s','NEW', UNIX_TIMESTAMP(),'%s','%s','%s','%s')",
		array(
			$subject,
			$text,
			$receiverList,
			$points,
			$seconds,
			$url,
			$cat,
			$target,
			bigintval($receiver),
		), __FUNCTION__, __LINE__);
	}
}

// Generate a receiver list for given category and maximum receivers
function generateReceiverList ($cat, $receiver, $mode = '') {
	// Init variables
	$CAT_TABS     = '';
	$CAT_WHERE    = '';
	$receiverList = '';
	$result       = false;

	// Secure data
	$cat      = bigintval($cat);
	$receiver = bigintval($receiver);

	// Is the receiver zero and mode set?
	if (($receiver == '0') && (!empty($mode))) {
		// Auto-fix receiver maximum
		$receiver = getTotalReceivers($mode);
	} // END - if

	// Category given?
	if ($cat > 0) {
		// Select category
		$CAT_TABS  = "LEFT JOIN `{?_MYSQL_PREFIX?}_user_cats` AS c ON d.`userid`=c.`userid`";
		$CAT_WHERE = sprintf(" AND c.`cat_id`=%s", $cat);
	} // END - if

	// Exclude users in holiday?
	if (isExtensionInstalledAndNewer('holiday', '0.1.3')) {
		// Add something for the holiday extension
		$CAT_WHERE .= " AND d.`holiday_active`='N'";
	} // END - if

	if ((isExtensionActive('html_mail')) && ($mode == 'html')) {
		// Only include HTML receivers
		$result = SQL_QUERY_ESC("SELECT d.userid FROM `{?_MYSQL_PREFIX?}_user_data` AS d ".$CAT_TABS." WHERE d.`status`='CONFIRMED' AND d.`html`='Y'".$CAT_WHERE." ORDER BY d.{?order_select?} {?order_mode?} LIMIT %s",
			array(
				$receiver
			), __FUNCTION__, __LINE__);
	} else {
		// Include all
		$result = SQL_QUERY_ESC("SELECT d.userid FROM `{?_MYSQL_PREFIX?}_user_data` AS d ".$CAT_TABS." WHERE d.`status`='CONFIRMED'".$CAT_WHERE." ORDER BY d.{?order_select?} {?order_mode?} LIMIT %s",
			array(
				$receiver
			), __FUNCTION__, __LINE__);
	}

	// Entries found?
	if ((SQL_NUMROWS($result) >= $receiver) && ($receiver > 0)) {
		// Load all entries
		while ($content = SQL_FETCHARRAY($result)) {
			// Add receiver when not empty
			if (!empty($content['userid'])) $receiverList .= $content['userid'] . ';';
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Remove trailing semicolon
		$receiverList = substr($receiverList, 0, -1);
	} // END - if

	// Return list
	return $receiverList;
}

// "Getter" for array for user refs and points in given level
function getUserReferalPoints ($userid, $level) {
	//* DEBUG: */ debugOutput('----------------------- <font color="#00aa00">'.__FUNCTION__.' - ENTRY</font> ------------------------<ul><li>');
	// Default is no refs and no nickname
	$add = '';
	$refs = array();

	// Do we have nickname extension installed?
	if (isExtensionActive('nickname')) {
		$add = ', ud.nickname';
	} // END - if

	// Get refs from database
	$result = SQL_QUERY_ESC("SELECT
	ur.id, ur.refid, ud.status, ud.last_online, ud.mails_confirmed, ud.emails_received".$add."
FROM
	`{?_MYSQL_PREFIX?}_user_refs` AS ur
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_points` AS up
ON
	ur.refid=up.userid AND ur.level=0
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_data` AS ud
ON
	ur.refid=ud.userid
WHERE
	ur.userid=%s AND ur.level=%s
ORDER BY
	ur.refid ASC",
		array(
			bigintval($userid),
			bigintval($level)
		), __FUNCTION__, __LINE__);

	// Are there some entries?
	if (!SQL_HASZERONUMS($result)) {
		// Fetch all entries
		while ($row = SQL_FETCHARRAY($result)) {
			// Get total points of this user
			$row['points'] = getTotalPoints($row['refid']);

			// Get unconfirmed mails
			$row['unconfirmed']  = countSumTotalData($row['refid'], 'user_links', 'id', 'userid', true);

			// Init clickrate with zero
			$row['clickrate'] = '0';

			// Is at least one mail received?
			if ($row['emails_received'] > 0) {
				// Calculate clickrate
				$row['clickrate'] = ($row['mails_confirmed'] / $row['emails_received'] * 100);
			} // END - if

			// Activity is 'active' by default because if autopurge is not installed
			$row['activity'] = '{--MEMBER_ACTIVITY_ACTIVE--}';

			// Is autopurge installed and the user inactive?
			if ((isExtensionActive('autopurge')) && ((time() - getApInactiveSince()) >= $row['last_online']))  {
				// Inactive user!
				$row['activity'] = '{--MEMBER_ACTIVITY_INACTIVE--}';
			} // END - if

			// Remove some entries
			unset($row['mails_confirmed']);
			unset($row['emails_received']);
			unset($row['last_online']);

			// Add row
			$refs[$row['id']] = $row;
		} // END - while
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return result
	//* DEBUG: */ debugOutput('</li></ul>----------------------- <font color="#aa0000">'.__FUNCTION__.' - EXIT</font> ------------------------<br />');
	return $refs;
}

// Recuce the amount of received emails for the receipients for given email
function reduceRecipientReceivedMails ($column, $id, $count) {
	// Search for mail in database
	$result = SQL_QUERY_ESC("SELECT * FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `%s`=%s ORDER BY `userid` ASC LIMIT %s",
		array($column, bigintval($id), $count), __FUNCTION__, __LINE__);

	// Are there entries?
	if (!SQL_HASZERONUMS($result)) {
		// Now load all userids for one big query!
		$userids = array();
		while ($data = SQL_FETCHARRAY($result)) {
			// By default we want to reduce and have no mails found
			$num = 0;

			// We must now look if he has already confirmed this mail, so might sound double, but it may resolve problems
			// @TODO Rewrite this to a filter
			if ((isset($data['stats_id'])) && ($data['stats_id'] > 0)) {
				// User email
				$num = countSumTotalData($data['userid'], 'user_stats_data', 'id', 'userid', true, sprintf(" AND `stats_type`='mailid' AND `stats_data`=%s", bigintval($data['stats_id'])));
			} elseif ((isset($data['bonus_id'])) && ($data['bonus_id'] > 0)) {
				// Bonus mail
				$num = countSumTotalData($data['userid'], 'user_stats_data', 'id', 'userid', true, sprintf(" AND `stats_type`='bonusid' AND `stats_data`=%s", bigintval($data['bonus_id'])));
			}

			// Reduce this users total received emails?
			if ($num === 0) $userids[$data['userid']] = $data['userid'];
		} // END - while

		if (count($userids) > 0) {
			// Now update all user accounts
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `emails_received`=`emails_received`-1 WHERE `userid` IN (%s) LIMIT %s",
				array(implode(',', $userids), count($userids)), __FUNCTION__, __LINE__);
		} else {
			// Nothing deleted
			loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_MAIL_NOTHING_DELETED', $id));
		}
	} // END - if

	// Free result
	SQL_FREERESULT($result);
}

// Creates a new task
function createNewTask ($subject, $notes, $taskType, $userid = '0', $adminId = '0', $strip = true) {
	// Insert the task data into the database
	SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_task_system` (`assigned_admin`, `userid`, `status`, `task_type`, `subject`, `text`, `task_created`) VALUES (%s,%s,'NEW','%s','%s','%s', UNIX_TIMESTAMP())",
		array(
			$adminId,
			$userid,
			$taskType,
			$subject,
			$notes
		), __FUNCTION__, __LINE__, true, $strip);

	// Return insert id which is the task id
	return SQL_INSERTID();
}

// Updates last module / online time
// @TODO Fix inconsistency between last_module and getWhat()
function updateLastActivity($userid) {
	// Run the update query
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `last_module`='%s', `last_online`=UNIX_TIMESTAMP(), `REMOTE_ADDR`='%s' WHERE `userid`=%s LIMIT 1",
		array(
			getWhat(),
			detectRemoteAddr(),
			bigintval($userid)
		), __FUNCTION__, __LINE__);
}

// [EOF]
?>
